#include "lichess.h"

#include <string.h>
#include <json-c/json_tokener.h>
#include <stdio.h>
#include <unistd.h>

json_object* query_lichess(char* username)
{
	/* This function queries the lichess api and returns a pointer to a
	 * json_object, that contains the profile of the queried player
	 */
	char* api_base = "https://lichess.org/api/user/";
	char user_url[128];
	strcpy(user_url,api_base);
	strcat(user_url,username);
	printf("querying %s\n",user_url);
	char* http_response = request(user_url);
	if(http_response == NULL)
	{
		printf("didn't receive HTTP response, we might be rate-limited. Waiting 60s");
		sleep(60);
		return NULL;
	}
	json_object *lichessUser = json_tokener_parse(http_response);
	json_object *profile = json_object_object_get(lichessUser,"profile");
	return profile;
}
